_newATCACommand:
;atca_command.c,64 :: 		ATCACommand newATCACommand( ATCADeviceType device_type )  // constructor
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atca_command.c,66 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R25, 4(SP)
SW	R26, 8(SP)
;atca_command.c,67 :: 		ATCACommand cacmd = (ATCACommand)Malloc(sizeof(struct atca_command));
SB	R25, 12(SP)
ORI	R25, R0, 8
JAL	_Malloc+0
NOP	
LBU	R25, 12(SP)
; cacmd start address is: 16 (R4)
MOVZ	R4, R2, R0
;atca_command.c,69 :: 		cacmd->dt = device_type;
SB	R25, 0(R2)
;atca_command.c,70 :: 		status = atInitExecTimes(cacmd, device_type);  // setup typical execution times for this device type
ANDI	R26, R25, 255
MOVZ	R25, R4, R0
JAL	_atInitExecTimes+0
NOP	
;atca_command.c,72 :: 		if (status != ATCA_SUCCESS) {
ANDI	R2, R2, 255
BNE	R2, R0, L__newATCACommand133
NOP	
J	L__newATCACommand105
NOP	
L__newATCACommand133:
;atca_command.c,73 :: 		Free((void*)cacmd, sizeof(cacmd));
ORI	R26, R0, 4
MOVZ	R25, R4, R0
; cacmd end address is: 16 (R4)
JAL	_Free+0
NOP	
;atca_command.c,74 :: 		cacmd = NULL;
; cacmd start address is: 8 (R2)
MOVZ	R2, R0, R0
; cacmd end address is: 8 (R2)
;atca_command.c,75 :: 		}
J	L_newATCACommand0
NOP	
L__newATCACommand105:
;atca_command.c,72 :: 		if (status != ATCA_SUCCESS) {
MOVZ	R2, R4, R0
;atca_command.c,75 :: 		}
L_newATCACommand0:
;atca_command.c,77 :: 		return cacmd;
; cacmd start address is: 8 (R2)
; cacmd end address is: 8 (R2)
;atca_command.c,78 :: 		}
;atca_command.c,77 :: 		return cacmd;
;atca_command.c,78 :: 		}
L_end_newATCACommand:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _newATCACommand
_atCheckMAC:
;atca_command.c,88 :: 		ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,91 :: 		packet->opcode = ATCA_CHECKMAC;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 40
SB	R2, 0(R3)
;atca_command.c,92 :: 		packet->txsize = CHECKMAC_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 84
SB	R2, 0(R3)
;atca_command.c,93 :: 		packet->rxsize = CHECKMAC_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,95 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,96 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,97 :: 		}
;atca_command.c,96 :: 		return ATCA_SUCCESS;
;atca_command.c,97 :: 		}
L_end_atCheckMAC:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atCheckMAC
_atCounter:
;atca_command.c,104 :: 		ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,106 :: 		if ( !atIsECCFamily( cacmd->dt ) )
SW	R25, 4(SP)
LBU	R25, 0(R25)
JAL	_atIsECCFamily+0
NOP	
BEQ	R2, R0, L__atCounter136
NOP	
J	L_atCounter1
NOP	
L__atCounter136:
;atca_command.c,107 :: 		return ATCA_BAD_OPCODE;
ORI	R2, R0, 242
J	L_end_atCounter
NOP	
L_atCounter1:
;atca_command.c,110 :: 		packet->opcode = ATCA_COUNTER;
ADDIU	R3, R26, 2
ORI	R2, R0, 36
SB	R2, 0(R3)
;atca_command.c,111 :: 		packet->txsize = COUNTER_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,112 :: 		packet->rxsize = COUNTER_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 7
SH	R2, 0(R3)
;atca_command.c,114 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,115 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,116 :: 		}
;atca_command.c,115 :: 		return ATCA_SUCCESS;
;atca_command.c,116 :: 		}
L_end_atCounter:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atCounter
_atDeriveKey:
;atca_command.c,124 :: 		ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet, bool hasMAC )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,127 :: 		packet->opcode = ATCA_DERIVE_KEY;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 28
SB	R2, 0(R3)
;atca_command.c,131 :: 		switch ( hasMAC ) {
J	L_atDeriveKey2
NOP	
;atca_command.c,132 :: 		case true:
L_atDeriveKey4:
;atca_command.c,133 :: 		packet->txsize = DERIVE_KEY_COUNT_LARGE;
ADDIU	R3, R26, 1
ORI	R2, R0, 39
SB	R2, 0(R3)
;atca_command.c,134 :: 		break;
J	L_atDeriveKey3
NOP	
;atca_command.c,135 :: 		case false:
L_atDeriveKey5:
;atca_command.c,136 :: 		packet->txsize = DERIVE_KEY_COUNT_SMALL;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,137 :: 		break;
J	L_atDeriveKey3
NOP	
;atca_command.c,138 :: 		}
L_atDeriveKey2:
ANDI	R3, R27, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atDeriveKey139
NOP	
J	L_atDeriveKey4
NOP	
L__atDeriveKey139:
ANDI	R2, R27, 255
BNE	R2, R0, L__atDeriveKey141
NOP	
J	L_atDeriveKey5
NOP	
L__atDeriveKey141:
L_atDeriveKey3:
;atca_command.c,140 :: 		packet->rxsize = DERIVE_KEY_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,141 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,142 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,143 :: 		}
;atca_command.c,142 :: 		return ATCA_SUCCESS;
;atca_command.c,143 :: 		}
L_end_atDeriveKey:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atDeriveKey
_atECDH:
;atca_command.c,150 :: 		ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,154 :: 		packet->opcode = ATCA_ECDH;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 67
SB	R2, 0(R3)
;atca_command.c,155 :: 		packet->txsize = ECDH_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 71
SB	R2, 0(R3)
;atca_command.c,156 :: 		packet->rxsize = ECDH_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
;atca_command.c,158 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,159 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,160 :: 		}
;atca_command.c,159 :: 		return ATCA_SUCCESS;
;atca_command.c,160 :: 		}
L_end_atECDH:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atECDH
_atGenDig:
;atca_command.c,168 :: 		ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet, bool hasMACKey )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,172 :: 		packet->opcode = ATCA_GENDIG;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 21
SB	R2, 0(R3)
;atca_command.c,174 :: 		if ( packet->param1 == 0x03 ) // shared nonce mode
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BEQ	R3, R2, L__atGenDig144
NOP	
J	L_atGenDig6
NOP	
L__atGenDig144:
;atca_command.c,175 :: 		packet->txsize = GENDIG_COUNT + 32;
ADDIU	R3, R26, 1
ORI	R2, R0, 39
SB	R2, 0(R3)
J	L_atGenDig7
NOP	
L_atGenDig6:
;atca_command.c,176 :: 		else if ( hasMACKey == true )
ANDI	R3, R27, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__atGenDig145
NOP	
J	L_atGenDig8
NOP	
L__atGenDig145:
;atca_command.c,177 :: 		packet->txsize = GENDIG_COUNT_DATA;
ADDIU	R3, R26, 1
ORI	R2, R0, 11
SB	R2, 0(R3)
J	L_atGenDig9
NOP	
L_atGenDig8:
;atca_command.c,179 :: 		packet->txsize = GENDIG_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
L_atGenDig9:
L_atGenDig7:
;atca_command.c,181 :: 		packet->rxsize = GENDIG_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,183 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,184 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,185 :: 		}
;atca_command.c,184 :: 		return ATCA_SUCCESS;
;atca_command.c,185 :: 		}
L_end_atGenDig:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atGenDig
_atGenKey:
;atca_command.c,193 :: 		ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet, bool isPubKey )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,197 :: 		packet->opcode = ATCA_GENKEY;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 64
SB	R2, 0(R3)
;atca_command.c,199 :: 		switch ( isPubKey ) {
J	L_atGenKey10
NOP	
;atca_command.c,200 :: 		case true:
L_atGenKey12:
;atca_command.c,201 :: 		packet->txsize = GENKEY_COUNT_DATA;
ADDIU	R3, R26, 1
ORI	R2, R0, 10
SB	R2, 0(R3)
;atca_command.c,202 :: 		break;
J	L_atGenKey11
NOP	
;atca_command.c,203 :: 		case false:
L_atGenKey13:
;atca_command.c,204 :: 		packet->txsize = GENKEY_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,205 :: 		break;
J	L_atGenKey11
NOP	
;atca_command.c,206 :: 		}
L_atGenKey10:
ANDI	R3, R27, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atGenKey148
NOP	
J	L_atGenKey12
NOP	
L__atGenKey148:
ANDI	R2, R27, 255
BNE	R2, R0, L__atGenKey150
NOP	
J	L_atGenKey13
NOP	
L__atGenKey150:
L_atGenKey11:
;atca_command.c,208 :: 		packet->rxsize = GENKEY_RSP_SIZE_LONG;
ADDIU	R3, R26, 138
ORI	R2, R0, 75
SH	R2, 0(R3)
;atca_command.c,210 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,211 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,212 :: 		}
;atca_command.c,211 :: 		return ATCA_SUCCESS;
;atca_command.c,212 :: 		}
L_end_atGenKey:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atGenKey
_atHMAC:
;atca_command.c,219 :: 		ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,223 :: 		packet->opcode = ATCA_HMAC;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 17
SB	R2, 0(R3)
;atca_command.c,224 :: 		packet->txsize = HMAC_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,225 :: 		packet->rxsize = HMAC_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
;atca_command.c,227 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,228 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,229 :: 		}
;atca_command.c,228 :: 		return ATCA_SUCCESS;
;atca_command.c,229 :: 		}
L_end_atHMAC:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atHMAC
_atInfo:
;atca_command.c,236 :: 		ATCA_STATUS atInfo( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,240 :: 		packet->opcode = ATCA_INFO;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 48
SB	R2, 0(R3)
;atca_command.c,241 :: 		packet->txsize = INFO_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,242 :: 		packet->rxsize = INFO_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 7
SH	R2, 0(R3)
;atca_command.c,244 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,245 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,246 :: 		}
;atca_command.c,245 :: 		return ATCA_SUCCESS;
;atca_command.c,246 :: 		}
L_end_atInfo:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atInfo
_atLock:
;atca_command.c,253 :: 		ATCA_STATUS atLock(  ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,257 :: 		packet->opcode = ATCA_LOCK;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 23
SB	R2, 0(R3)
;atca_command.c,258 :: 		packet->txsize = LOCK_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,259 :: 		packet->rxsize = LOCK_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,261 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,262 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,263 :: 		}
;atca_command.c,262 :: 		return ATCA_SUCCESS;
;atca_command.c,263 :: 		}
L_end_atLock:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atLock
_atMAC:
;atca_command.c,270 :: 		ATCA_STATUS atMAC( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,275 :: 		packet->opcode = ATCA_MAC;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 8
SB	R2, 0(R3)
;atca_command.c,276 :: 		if ( packet->param1 == 0 )
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__atMAC155
NOP	
J	L_atMAC14
NOP	
L__atMAC155:
;atca_command.c,277 :: 		packet->txsize = MAC_COUNT_LONG;
ADDIU	R3, R26, 1
ORI	R2, R0, 39
SB	R2, 0(R3)
J	L_atMAC15
NOP	
L_atMAC14:
;atca_command.c,279 :: 		packet->txsize = MAC_COUNT_SHORT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
L_atMAC15:
;atca_command.c,281 :: 		packet->rxsize = MAC_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
;atca_command.c,283 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,284 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,285 :: 		}
;atca_command.c,284 :: 		return ATCA_SUCCESS;
;atca_command.c,285 :: 		}
L_end_atMAC:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atMAC
_atNonce:
;atca_command.c,292 :: 		ATCA_STATUS atNonce( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,297 :: 		packet->opcode = ATCA_NONCE;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 22
SB	R2, 0(R3)
;atca_command.c,298 :: 		mode = packet->param1 & 0x03;
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R2, R2, 3
; mode start address is: 16 (R4)
ANDI	R4, R2, 255
;atca_command.c,300 :: 		if ( (mode == 0 || mode == 1) ) {       // mode[0:1] == 0 | 1 then NumIn is 20 bytes
SEH	R2, R4
BNE	R2, R0, L__atNonce158
NOP	
J	L__atNonce109
NOP	
L__atNonce158:
SEH	R3, R4
ORI	R2, R0, 1
BNE	R3, R2, L__atNonce160
NOP	
J	L__atNonce108
NOP	
L__atNonce160:
J	L_atNonce18
NOP	
; mode end address is: 16 (R4)
L__atNonce109:
L__atNonce108:
;atca_command.c,301 :: 		packet->txsize = NONCE_COUNT_SHORT; // 20 byte challenge
ADDIU	R3, R26, 1
ORI	R2, R0, 27
SB	R2, 0(R3)
;atca_command.c,302 :: 		packet->rxsize = NONCE_RSP_SIZE_LONG;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
;atca_command.c,303 :: 		} else if ( mode == 0x03 ) {            // NumIn is 32 bytes
J	L_atNonce19
NOP	
L_atNonce18:
; mode start address is: 16 (R4)
SEH	R3, R4
; mode end address is: 16 (R4)
ORI	R2, R0, 3
BEQ	R3, R2, L__atNonce161
NOP	
J	L_atNonce20
NOP	
L__atNonce161:
;atca_command.c,304 :: 		packet->txsize = NONCE_COUNT_LONG;  // 32 byte challenge
ADDIU	R3, R26, 1
ORI	R2, R0, 39
SB	R2, 0(R3)
;atca_command.c,305 :: 		packet->rxsize = NONCE_RSP_SIZE_SHORT;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,306 :: 		} else
J	L_atNonce21
NOP	
L_atNonce20:
;atca_command.c,307 :: 		return ATCA_BAD_PARAM;
ORI	R2, R0, 226
J	L_end_atNonce
NOP	
L_atNonce21:
L_atNonce19:
;atca_command.c,309 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,310 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,311 :: 		}
;atca_command.c,310 :: 		return ATCA_SUCCESS;
;atca_command.c,311 :: 		}
L_end_atNonce:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atNonce
_atPause:
;atca_command.c,318 :: 		ATCA_STATUS atPause( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,321 :: 		packet->opcode = ATCA_PAUSE;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 1
SB	R2, 0(R3)
;atca_command.c,322 :: 		packet->txsize = PAUSE_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,323 :: 		packet->rxsize = PAUSE_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,325 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,326 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,327 :: 		}
;atca_command.c,326 :: 		return ATCA_SUCCESS;
;atca_command.c,327 :: 		}
L_end_atPause:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atPause
_atPrivWrite:
;atca_command.c,334 :: 		ATCA_STATUS atPrivWrite( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,337 :: 		packet->opcode = ATCA_PRIVWRITE;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 70
SB	R2, 0(R3)
;atca_command.c,338 :: 		packet->txsize = PRIVWRITE_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 75
SB	R2, 0(R3)
;atca_command.c,339 :: 		packet->rxsize = PRIVWRITE_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,341 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,342 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,343 :: 		}
;atca_command.c,342 :: 		return ATCA_SUCCESS;
;atca_command.c,343 :: 		}
L_end_atPrivWrite:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atPrivWrite
_atRandom:
;atca_command.c,350 :: 		ATCA_STATUS atRandom( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,354 :: 		packet->opcode = ATCA_RANDOM;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 27
SB	R2, 0(R3)
;atca_command.c,355 :: 		packet->txsize = RANDOM_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,356 :: 		packet->rxsize = RANDOM_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
;atca_command.c,358 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,359 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,360 :: 		}
;atca_command.c,359 :: 		return ATCA_SUCCESS;
;atca_command.c,360 :: 		}
L_end_atRandom:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atRandom
_atRead:
;atca_command.c,367 :: 		ATCA_STATUS atRead( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,371 :: 		packet->opcode = ATCA_READ;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 2
SB	R2, 0(R3)
;atca_command.c,372 :: 		packet->txsize = READ_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,375 :: 		if ((packet->param1 & 0x80) == 0 )
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R2, R2, 128
ANDI	R2, R2, 255
BEQ	R2, R0, L__atRead166
NOP	
J	L_atRead22
NOP	
L__atRead166:
;atca_command.c,376 :: 		packet->rxsize = READ_4_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 7
SH	R2, 0(R3)
J	L_atRead23
NOP	
L_atRead22:
;atca_command.c,378 :: 		packet->rxsize = READ_32_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
L_atRead23:
;atca_command.c,380 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,381 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,382 :: 		}
;atca_command.c,381 :: 		return ATCA_SUCCESS;
;atca_command.c,382 :: 		}
L_end_atRead:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atRead
_atSHA:
;atca_command.c,389 :: 		ATCA_STATUS atSHA( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,391 :: 		if ( packet->param2 > SHA_BLOCK_SIZE )
SW	R25, 4(SP)
ADDIU	R2, R26, 4
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 65
BEQ	R2, R0, L__atSHA168
NOP	
J	L_atSHA24
NOP	
L__atSHA168:
;atca_command.c,392 :: 		return ATCA_BAD_PARAM;
ORI	R2, R0, 226
J	L_end_atSHA
NOP	
L_atSHA24:
;atca_command.c,394 :: 		if ( packet->param1 == 0x01 && packet->param2 != SHA_BLOCK_SIZE )
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__atSHA169
NOP	
J	L__atSHA113
NOP	
L__atSHA169:
ADDIU	R2, R26, 4
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 64
BNE	R3, R2, L__atSHA171
NOP	
J	L__atSHA112
NOP	
L__atSHA171:
L__atSHA111:
;atca_command.c,395 :: 		return ATCA_BAD_PARAM;                                              // updates should always have 64 bytes of data
ORI	R2, R0, 226
J	L_end_atSHA
NOP	
;atca_command.c,394 :: 		if ( packet->param1 == 0x01 && packet->param2 != SHA_BLOCK_SIZE )
L__atSHA113:
L__atSHA112:
;atca_command.c,397 :: 		if ( packet->param1 == 0x02 && packet->param2 > SHA_BLOCK_SIZE - 1 )    // END should be 0-63 bytes
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BEQ	R3, R2, L__atSHA172
NOP	
J	L__atSHA115
NOP	
L__atSHA172:
ADDIU	R2, R26, 4
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 64
BEQ	R2, R0, L__atSHA173
NOP	
J	L__atSHA114
NOP	
L__atSHA173:
L__atSHA110:
;atca_command.c,398 :: 		return ATCA_BAD_PARAM;
ORI	R2, R0, 226
J	L_end_atSHA
NOP	
;atca_command.c,397 :: 		if ( packet->param1 == 0x02 && packet->param2 > SHA_BLOCK_SIZE - 1 )    // END should be 0-63 bytes
L__atSHA115:
L__atSHA114:
;atca_command.c,401 :: 		packet->opcode = ATCA_SHA;
ADDIU	R3, R26, 2
ORI	R2, R0, 71
SB	R2, 0(R3)
;atca_command.c,403 :: 		switch ( packet->param1 ) {
ADDIU	R4, R26, 3
J	L_atSHA31
NOP	
;atca_command.c,404 :: 		case 0x00: // START
L_atSHA33:
;atca_command.c,405 :: 		packet->rxsize = SHA_RSP_SIZE_SHORT;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,406 :: 		packet->txsize = SHA_COUNT_LONG;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,407 :: 		break;
J	L_atSHA32
NOP	
;atca_command.c,408 :: 		case 0x01: // UPDATE
L_atSHA34:
;atca_command.c,409 :: 		packet->rxsize = SHA_RSP_SIZE_SHORT;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,410 :: 		packet->txsize = SHA_COUNT_LONG + SHA_BLOCK_SIZE;
ADDIU	R3, R26, 1
ORI	R2, R0, 71
SB	R2, 0(R3)
;atca_command.c,411 :: 		break;
J	L_atSHA32
NOP	
;atca_command.c,412 :: 		case 0x02: // END
L_atSHA35:
;atca_command.c,413 :: 		packet->rxsize = SHA_RSP_SIZE_LONG;
ADDIU	R3, R26, 138
ORI	R2, R0, 35
SH	R2, 0(R3)
;atca_command.c,416 :: 		packet->txsize = SHA_COUNT_LONG + packet->param2;
ADDIU	R3, R26, 1
ADDIU	R2, R26, 4
LHU	R2, 0(R2)
ADDIU	R2, R2, 7
SB	R2, 0(R3)
;atca_command.c,417 :: 		break;
J	L_atSHA32
NOP	
;atca_command.c,418 :: 		}
L_atSHA31:
LBU	R2, 0(R4)
ANDI	R2, R2, 255
BNE	R2, R0, L__atSHA175
NOP	
J	L_atSHA33
NOP	
L__atSHA175:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atSHA177
NOP	
J	L_atSHA34
NOP	
L__atSHA177:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BNE	R3, R2, L__atSHA179
NOP	
J	L_atSHA35
NOP	
L__atSHA179:
L_atSHA32:
;atca_command.c,420 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,421 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,422 :: 		}
;atca_command.c,421 :: 		return ATCA_SUCCESS;
;atca_command.c,422 :: 		}
L_end_atSHA:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atSHA
_atSign:
;atca_command.c,429 :: 		ATCA_STATUS atSign( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,433 :: 		packet->opcode = ATCA_SIGN;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 65
SB	R2, 0(R3)
;atca_command.c,434 :: 		packet->txsize = SIGN_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,437 :: 		packet->rxsize = ATCA_RSP_SIZE_64;
ADDIU	R3, R26, 138
ORI	R2, R0, 67
SH	R2, 0(R3)
;atca_command.c,439 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,440 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,441 :: 		}
;atca_command.c,440 :: 		return ATCA_SUCCESS;
;atca_command.c,441 :: 		}
L_end_atSign:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atSign
_atUpdateExtra:
;atca_command.c,448 :: 		ATCA_STATUS atUpdateExtra( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,452 :: 		packet->opcode = ATCA_UPDATE_EXTRA;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 32
SB	R2, 0(R3)
;atca_command.c,453 :: 		packet->txsize = UPDATE_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 7
SB	R2, 0(R3)
;atca_command.c,454 :: 		packet->rxsize = UPDATE_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,456 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,457 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,458 :: 		}
;atca_command.c,457 :: 		return ATCA_SUCCESS;
;atca_command.c,458 :: 		}
L_end_atUpdateExtra:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atUpdateExtra
_atVerify:
;atca_command.c,465 :: 		ATCA_STATUS atVerify( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,469 :: 		packet->opcode = ATCA_VERIFY;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 69
SB	R2, 0(R3)
;atca_command.c,472 :: 		switch ( packet->param1 ) {
ADDIU	R4, R26, 3
J	L_atVerify36
NOP	
;atca_command.c,473 :: 		case 0:  // Stored mode
L_atVerify38:
;atca_command.c,474 :: 		packet->txsize = VERIFY_256_STORED_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 71
SB	R2, 0(R3)
;atca_command.c,475 :: 		break;
J	L_atVerify37
NOP	
;atca_command.c,476 :: 		case 1:  // ValidateExternal mode
L_atVerify39:
;atca_command.c,477 :: 		packet->txsize = VERIFY_256_EXTERNAL_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 135
SB	R2, 0(R3)
;atca_command.c,478 :: 		break;
J	L_atVerify37
NOP	
;atca_command.c,479 :: 		case 2:  // External mode
L_atVerify40:
;atca_command.c,480 :: 		packet->txsize = VERIFY_256_EXTERNAL_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 135
SB	R2, 0(R3)
;atca_command.c,481 :: 		break;
J	L_atVerify37
NOP	
;atca_command.c,482 :: 		case 3:     // Validate mode
L_atVerify41:
;atca_command.c,483 :: 		case 7:     // Invalidate mode
L_atVerify42:
;atca_command.c,484 :: 		packet->txsize = VERIFY_256_VALIDATE_COUNT;
ADDIU	R3, R26, 1
ORI	R2, R0, 90
SB	R2, 0(R3)
;atca_command.c,485 :: 		break;
J	L_atVerify37
NOP	
;atca_command.c,486 :: 		default:
L_atVerify43:
;atca_command.c,487 :: 		return ATCA_BAD_PARAM;
ORI	R2, R0, 226
J	L_end_atVerify
NOP	
;atca_command.c,488 :: 		}
L_atVerify36:
LBU	R2, 0(R4)
ANDI	R2, R2, 255
BNE	R2, R0, L__atVerify184
NOP	
J	L_atVerify38
NOP	
L__atVerify184:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atVerify186
NOP	
J	L_atVerify39
NOP	
L__atVerify186:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BNE	R3, R2, L__atVerify188
NOP	
J	L_atVerify40
NOP	
L__atVerify188:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BNE	R3, R2, L__atVerify190
NOP	
J	L_atVerify41
NOP	
L__atVerify190:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 7
BNE	R3, R2, L__atVerify192
NOP	
J	L_atVerify42
NOP	
L__atVerify192:
J	L_atVerify43
NOP	
L_atVerify37:
;atca_command.c,489 :: 		packet->rxsize = VERIFY_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,491 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,492 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,493 :: 		}
;atca_command.c,492 :: 		return ATCA_SUCCESS;
;atca_command.c,493 :: 		}
L_end_atVerify:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atVerify
_atWrite:
;atca_command.c,500 :: 		ATCA_STATUS atWrite( ATCACommand cacmd, ATCAPacket *packet )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,506 :: 		packet->opcode = ATCA_WRITE;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 18
SB	R2, 0(R3)
;atca_command.c,508 :: 		macsize = ( packet->param1 & 0x40 ? 32 : 0 );  // if encrypted, use MAC
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R2, R2, 64
BNE	R2, R0, L__atWrite195
NOP	
J	L_atWrite44
NOP	
L__atWrite195:
; ?FLOC___atWrite?T472 start address is: 8 (R2)
ORI	R2, R0, 32
; ?FLOC___atWrite?T472 end address is: 8 (R2)
J	L_atWrite45
NOP	
L_atWrite44:
; ?FLOC___atWrite?T472 start address is: 8 (R2)
MOVZ	R2, R0, R0
; ?FLOC___atWrite?T472 end address is: 8 (R2)
L_atWrite45:
; ?FLOC___atWrite?T472 start address is: 8 (R2)
; macsize start address is: 16 (R4)
SEB	R4, R2
; ?FLOC___atWrite?T472 end address is: 8 (R2)
;atca_command.c,509 :: 		writesize = ( packet->param1 & 0x80 ? 32 : 4 );
ADDIU	R2, R26, 3
LBU	R2, 0(R2)
ANDI	R2, R2, 128
BNE	R2, R0, L__atWrite197
NOP	
J	L_atWrite46
NOP	
L__atWrite197:
; ?FLOC___atWrite?T479 start address is: 8 (R2)
ORI	R2, R0, 32
; ?FLOC___atWrite?T479 end address is: 8 (R2)
J	L_atWrite47
NOP	
L_atWrite46:
; ?FLOC___atWrite?T479 start address is: 8 (R2)
ORI	R2, R0, 4
; ?FLOC___atWrite?T479 end address is: 8 (R2)
L_atWrite47:
; ?FLOC___atWrite?T479 start address is: 8 (R2)
; writesize start address is: 20 (R5)
SEB	R5, R2
; ?FLOC___atWrite?T479 end address is: 8 (R2)
;atca_command.c,511 :: 		if ( macsize == 32 && writesize == 32 )
SEH	R3, R4
ORI	R2, R0, 32
BEQ	R3, R2, L__atWrite198
NOP	
J	L__atWrite121
NOP	
L__atWrite198:
SEH	R3, R5
ORI	R2, R0, 32
BEQ	R3, R2, L__atWrite199
NOP	
J	L__atWrite120
NOP	
L__atWrite199:
; macsize end address is: 16 (R4)
; writesize end address is: 20 (R5)
L__atWrite119:
;atca_command.c,512 :: 		packet->txsize = WRITE_COUNT_LONG_MAC;
ADDIU	R3, R26, 1
ORI	R2, R0, 71
SB	R2, 0(R3)
J	L_atWrite51
NOP	
;atca_command.c,511 :: 		if ( macsize == 32 && writesize == 32 )
L__atWrite121:
; writesize start address is: 20 (R5)
; macsize start address is: 16 (R4)
L__atWrite120:
;atca_command.c,513 :: 		else if ( macsize == 32 && writesize == 4 )
SEH	R3, R4
ORI	R2, R0, 32
BEQ	R3, R2, L__atWrite200
NOP	
J	L__atWrite123
NOP	
L__atWrite200:
SEH	R3, R5
ORI	R2, R0, 4
BEQ	R3, R2, L__atWrite201
NOP	
J	L__atWrite122
NOP	
L__atWrite201:
; macsize end address is: 16 (R4)
; writesize end address is: 20 (R5)
L__atWrite118:
;atca_command.c,514 :: 		packet->txsize = WRITE_COUNT_SHORT_MAC;
ADDIU	R3, R26, 1
ORI	R2, R0, 43
SB	R2, 0(R3)
J	L_atWrite55
NOP	
;atca_command.c,513 :: 		else if ( macsize == 32 && writesize == 4 )
L__atWrite123:
; writesize start address is: 20 (R5)
; macsize start address is: 16 (R4)
L__atWrite122:
;atca_command.c,515 :: 		else if ( macsize == 0 && writesize == 32 )
SEH	R2, R4
BEQ	R2, R0, L__atWrite202
NOP	
J	L__atWrite125
NOP	
L__atWrite202:
SEH	R3, R5
ORI	R2, R0, 32
BEQ	R3, R2, L__atWrite203
NOP	
J	L__atWrite124
NOP	
L__atWrite203:
; macsize end address is: 16 (R4)
; writesize end address is: 20 (R5)
L__atWrite117:
;atca_command.c,516 :: 		packet->txsize = WRITE_COUNT_LONG;
ADDIU	R3, R26, 1
ORI	R2, R0, 39
SB	R2, 0(R3)
J	L_atWrite59
NOP	
;atca_command.c,515 :: 		else if ( macsize == 0 && writesize == 32 )
L__atWrite125:
; writesize start address is: 20 (R5)
; macsize start address is: 16 (R4)
L__atWrite124:
;atca_command.c,517 :: 		else if ( macsize == 0 && writesize == 4 )
SEH	R2, R4
; macsize end address is: 16 (R4)
BEQ	R2, R0, L__atWrite204
NOP	
J	L__atWrite127
NOP	
L__atWrite204:
SEH	R3, R5
; writesize end address is: 20 (R5)
ORI	R2, R0, 4
BEQ	R3, R2, L__atWrite205
NOP	
J	L__atWrite126
NOP	
L__atWrite205:
L__atWrite116:
;atca_command.c,518 :: 		packet->txsize = WRITE_COUNT_SHORT;
ADDIU	R3, R26, 1
ORI	R2, R0, 11
SB	R2, 0(R3)
;atca_command.c,517 :: 		else if ( macsize == 0 && writesize == 4 )
L__atWrite127:
L__atWrite126:
;atca_command.c,518 :: 		packet->txsize = WRITE_COUNT_SHORT;
L_atWrite59:
L_atWrite55:
L_atWrite51:
;atca_command.c,520 :: 		packet->rxsize = WRITE_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,521 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,522 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,523 :: 		}
;atca_command.c,522 :: 		return ATCA_SUCCESS;
;atca_command.c,523 :: 		}
L_end_atWrite:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atWrite
_atWriteEnc:
;atca_command.c,530 :: 		ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_command.c,533 :: 		packet->opcode = ATCA_WRITE;
SW	R25, 4(SP)
ADDIU	R3, R26, 2
ORI	R2, R0, 18
SB	R2, 0(R3)
;atca_command.c,534 :: 		packet->txsize = WRITE_COUNT_LONG_MAC;
ADDIU	R3, R26, 1
ORI	R2, R0, 71
SB	R2, 0(R3)
;atca_command.c,535 :: 		packet->rxsize = WRITE_RSP_SIZE;
ADDIU	R3, R26, 138
ORI	R2, R0, 4
SH	R2, 0(R3)
;atca_command.c,536 :: 		atCalcCrc( packet );
MOVZ	R25, R26, R0
JAL	_atCalcCrc+0
NOP	
;atca_command.c,537 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,538 :: 		}
;atca_command.c,537 :: 		return ATCA_SUCCESS;
;atca_command.c,538 :: 		}
L_end_atWriteEnc:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atWriteEnc
_deleteATCACommand:
;atca_command.c,544 :: 		void deleteATCACommand( ATCACommand *cacmd )  // destructor
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atca_command.c,546 :: 		if ( *cacmd )
SW	R26, 4(SP)
LW	R2, 0(R25)
BNE	R2, R0, L__deleteATCACommand209
NOP	
J	L_deleteATCACommand63
NOP	
L__deleteATCACommand209:
;atca_command.c,547 :: 		Free((void*)*cacmd,sizeof(*cacmd));
LW	R2, 0(R25)
SW	R25, 8(SP)
ORI	R26, R0, 4
MOVZ	R25, R2, R0
JAL	_Free+0
NOP	
LW	R25, 8(SP)
L_deleteATCACommand63:
;atca_command.c,549 :: 		*cacmd = NULL;
SW	R0, 0(R25)
;atca_command.c,550 :: 		}
L_end_deleteATCACommand:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _deleteATCACommand
_atInitExecTimes:
;atca_command.c,613 :: 		ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type)
;atca_command.c,615 :: 		switch ( device_type ) {
J	L_atInitExecTimes64
NOP	
;atca_command.c,616 :: 		case ATECC108A:
L_atInitExecTimes66:
;atca_command.c,617 :: 		case ATECC508A:
L_atInitExecTimes67:
;atca_command.c,618 :: 		cacmd->execution_times = exectimes_x08a;
ADDIU	R3, R25, 4
LUI	R2, hi_addr(_exectimes_x08a+0)
ORI	R2, R2, lo_addr(_exectimes_x08a+0)
SW	R2, 0(R3)
;atca_command.c,619 :: 		break;
J	L_atInitExecTimes65
NOP	
;atca_command.c,620 :: 		case ATSHA204A:
L_atInitExecTimes68:
;atca_command.c,621 :: 		cacmd->execution_times = exectimes_204a;
ADDIU	R3, R25, 4
LUI	R2, hi_addr(_exectimes_204a+0)
ORI	R2, R2, lo_addr(_exectimes_204a+0)
SW	R2, 0(R3)
;atca_command.c,622 :: 		break;
J	L_atInitExecTimes65
NOP	
;atca_command.c,623 :: 		default:
L_atInitExecTimes69:
;atca_command.c,624 :: 		return ATCA_BAD_PARAM;
ORI	R2, R0, 226
J	L_end_atInitExecTimes
NOP	
;atca_command.c,626 :: 		}
L_atInitExecTimes64:
ANDI	R3, R26, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atInitExecTimes212
NOP	
J	L_atInitExecTimes66
NOP	
L__atInitExecTimes212:
ANDI	R3, R26, 255
ORI	R2, R0, 2
BNE	R3, R2, L__atInitExecTimes214
NOP	
J	L_atInitExecTimes67
NOP	
L__atInitExecTimes214:
ANDI	R2, R26, 255
BNE	R2, R0, L__atInitExecTimes216
NOP	
J	L_atInitExecTimes68
NOP	
L__atInitExecTimes216:
J	L_atInitExecTimes69
NOP	
L_atInitExecTimes65:
;atca_command.c,628 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,629 :: 		}
L_end_atInitExecTimes:
JR	RA
NOP	
; end of _atInitExecTimes
_atGetExecTime:
;atca_command.c,638 :: 		uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd )
;atca_command.c,640 :: 		return cacmd->execution_times[cmd];
ADDIU	R2, R25, 4
LW	R3, 0(R2)
ANDI	R2, R26, 255
SLL	R2, R2, 1
ADDU	R2, R3, R2
LHU	R2, 0(R2)
;atca_command.c,641 :: 		}
L_end_atGetExecTime:
JR	RA
NOP	
; end of _atGetExecTime
_atCRC:
;atca_command.c,651 :: 		void atCRC( uint8_t length, uint8_t *data, uint8_t *crc)
;atca_command.c,654 :: 		uint16_t crc_register = 0;
; crc_register start address is: 16 (R4)
MOVZ	R4, R0, R0
;atca_command.c,655 :: 		uint16_t polynom = 0x8005;
; polynom start address is: 20 (R5)
ORI	R5, R0, 32773
;atca_command.c,659 :: 		for (counter = 0; counter < length; counter++) {
; counter start address is: 24 (R6)
MOVZ	R6, R0, R0
; crc_register end address is: 16 (R4)
; polynom end address is: 20 (R5)
; counter end address is: 24 (R6)
L_atCRC70:
; counter start address is: 24 (R6)
; polynom start address is: 20 (R5)
; crc_register start address is: 16 (R4)
ANDI	R3, R6, 255
ANDI	R2, R25, 255
SLTU	R2, R3, R2
BNE	R2, R0, L__atCRC219
NOP	
J	L_atCRC71
NOP	
L__atCRC219:
;atca_command.c,660 :: 		for (shift_register = 0x01; shift_register > 0x00; shift_register <<= 1) {
; shift_register start address is: 28 (R7)
ORI	R7, R0, 1
; crc_register end address is: 16 (R4)
; polynom end address is: 20 (R5)
; shift_register end address is: 28 (R7)
; counter end address is: 24 (R6)
ANDI	R3, R4, 65535
L_atCRC73:
; shift_register start address is: 28 (R7)
; crc_register start address is: 12 (R3)
; polynom start address is: 20 (R5)
; counter start address is: 24 (R6)
ANDI	R2, R7, 255
SLTIU	R2, R2, 1
BEQ	R2, R0, L__atCRC220
NOP	
J	L_atCRC74
NOP	
L__atCRC220:
;atca_command.c,661 :: 		data_bit = (data[counter] & shift_register) ? 1 : 0;
ANDI	R2, R6, 255
ADDU	R2, R26, R2
LBU	R2, 0(R2)
AND	R2, R2, R7
BNE	R2, R0, L__atCRC222
NOP	
J	L_atCRC76
NOP	
L__atCRC222:
; ?FLOC___atCRC?T562 start address is: 32 (R8)
ORI	R8, R0, 1
; ?FLOC___atCRC?T562 end address is: 32 (R8)
J	L_atCRC77
NOP	
L_atCRC76:
; ?FLOC___atCRC?T562 start address is: 32 (R8)
MOVZ	R8, R0, R0
; ?FLOC___atCRC?T562 end address is: 32 (R8)
L_atCRC77:
;atca_command.c,662 :: 		crc_bit = crc_register >> 15;
; ?FLOC___atCRC?T562 start address is: 32 (R8)
ANDI	R2, R3, 65535
SRL	R4, R2, 15
;atca_command.c,663 :: 		crc_register <<= 1;
ANDI	R2, R3, 65535
; crc_register end address is: 12 (R3)
SLL	R2, R2, 1
; crc_register start address is: 36 (R9)
ANDI	R9, R2, 65535
;atca_command.c,664 :: 		if (data_bit != crc_bit)
ANDI	R3, R8, 255
; ?FLOC___atCRC?T562 end address is: 32 (R8)
ANDI	R2, R4, 255
BNE	R3, R2, L__atCRC224
NOP	
J	L__atCRC106
NOP	
L__atCRC224:
;atca_command.c,665 :: 		crc_register ^= polynom;
XOR	R2, R9, R5
; crc_register end address is: 36 (R9)
; crc_register start address is: 12 (R3)
ANDI	R3, R2, 65535
; crc_register end address is: 12 (R3)
J	L_atCRC78
NOP	
L__atCRC106:
;atca_command.c,664 :: 		if (data_bit != crc_bit)
ANDI	R3, R9, 65535
;atca_command.c,665 :: 		crc_register ^= polynom;
L_atCRC78:
;atca_command.c,660 :: 		for (shift_register = 0x01; shift_register > 0x00; shift_register <<= 1) {
; crc_register start address is: 12 (R3)
ANDI	R2, R7, 255
; shift_register end address is: 28 (R7)
SLL	R2, R2, 1
; shift_register start address is: 28 (R7)
ANDI	R7, R2, 255
;atca_command.c,666 :: 		}
; shift_register end address is: 28 (R7)
J	L_atCRC73
NOP	
L_atCRC74:
;atca_command.c,659 :: 		for (counter = 0; counter < length; counter++) {
ADDIU	R2, R6, 1
ANDI	R6, R2, 255
;atca_command.c,667 :: 		}
ANDI	R4, R3, 65535
; polynom end address is: 20 (R5)
; crc_register end address is: 12 (R3)
; counter end address is: 24 (R6)
J	L_atCRC70
NOP	
L_atCRC71:
;atca_command.c,668 :: 		crc[0] = (uint8_t)(crc_register & 0x00FF);
; crc_register start address is: 16 (R4)
ANDI	R2, R4, 255
SB	R2, 0(R27)
;atca_command.c,669 :: 		crc[1] = (uint8_t)(crc_register >> 8);
ADDIU	R3, R27, 1
ANDI	R2, R4, 65535
; crc_register end address is: 16 (R4)
SRL	R2, R2, 8
SB	R2, 0(R3)
;atca_command.c,670 :: 		}
L_end_atCRC:
JR	RA
NOP	
; end of _atCRC
_atCalcCrc:
;atca_command.c,677 :: 		void atCalcCrc( ATCAPacket *packet )
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atca_command.c,681 :: 		length = packet->txsize - ATCA_CRC_SIZE;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
ADDIU	R4, R25, 1
LBU	R2, 0(R4)
ADDIU	R3, R2, -2
;atca_command.c,683 :: 		crc = &(packet->txsize) + length;
ANDI	R2, R3, 255
ADDU	R2, R4, R2
;atca_command.c,686 :: 		atCRC(length, &(packet->txsize), crc);
MOVZ	R27, R2, R0
MOVZ	R26, R4, R0
ANDI	R25, R3, 255
JAL	_atCRC+0
NOP	
;atca_command.c,687 :: 		}
L_end_atCalcCrc:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _atCalcCrc
_atCheckCrc:
;atca_command.c,695 :: 		uint8_t atCheckCrc(uint8_t *response)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;atca_command.c,698 :: 		uint8_t count = response[ATCA_COUNT_IDX];
SW	R26, 4(SP)
SW	R27, 8(SP)
LBU	R2, 0(R25)
;atca_command.c,700 :: 		count -= ATCA_CRC_SIZE;
ADDIU	R3, R2, -2
; count start address is: 40 (R10)
ANDI	R10, R3, 255
;atca_command.c,701 :: 		atCRC(count, response, crc);
ADDIU	R2, SP, 16
SW	R25, 12(SP)
MOVZ	R27, R2, R0
MOVZ	R26, R25, R0
ANDI	R25, R3, 255
JAL	_atCRC+0
NOP	
LW	R25, 12(SP)
;atca_command.c,703 :: 		return (crc[0] == response[count] && crc[1] == response[count + 1]) ? ATCA_SUCCESS : ATCA_BAD_CRC;
ADDIU	R2, SP, 16
LBU	R3, 0(R2)
ANDI	R2, R10, 255
ADDU	R2, R25, R2
LBU	R2, 0(R2)
ANDI	R3, R3, 255
ANDI	R2, R2, 255
BEQ	R3, R2, L__atCheckCrc227
NOP	
J	L__atCheckCrc130
NOP	
L__atCheckCrc227:
ADDIU	R2, SP, 16
ADDIU	R3, R2, 1
ANDI	R2, R10, 255
; count end address is: 40 (R10)
ADDIU	R2, R2, 1
SEH	R2, R2
ADDU	R2, R25, R2
LBU	R4, 0(R2)
LBU	R2, 0(R3)
ANDI	R3, R2, 255
ANDI	R2, R4, 255
BEQ	R3, R2, L__atCheckCrc228
NOP	
J	L__atCheckCrc129
NOP	
L__atCheckCrc228:
L__atCheckCrc128:
; ?FLOC___atCheckCrc?T619 start address is: 8 (R2)
MOVZ	R2, R0, R0
; ?FLOC___atCheckCrc?T619 end address is: 8 (R2)
J	L_atCheckCrc82
NOP	
L__atCheckCrc130:
L__atCheckCrc129:
; ?FLOC___atCheckCrc?T619 start address is: 8 (R2)
ORI	R2, R0, 229
; ?FLOC___atCheckCrc?T619 end address is: 8 (R2)
L_atCheckCrc82:
; ?FLOC___atCheckCrc?T619 start address is: 8 (R2)
; ?FLOC___atCheckCrc?T619 end address is: 8 (R2)
;atca_command.c,704 :: 		}
;atca_command.c,703 :: 		return (crc[0] == response[count] && crc[1] == response[count + 1]) ? ATCA_SUCCESS : ATCA_BAD_CRC;
;atca_command.c,704 :: 		}
L_end_atCheckCrc:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _atCheckCrc
_atIsSHAFamily:
;atca_command.c,712 :: 		bool atIsSHAFamily( ATCADeviceType deviceType )
;atca_command.c,714 :: 		switch (deviceType) {
J	L_atIsSHAFamily83
NOP	
;atca_command.c,715 :: 		case ATSHA204A:
L_atIsSHAFamily85:
;atca_command.c,716 :: 		case ATECC108A:
L_atIsSHAFamily86:
;atca_command.c,717 :: 		case ATECC508A:
L_atIsSHAFamily87:
;atca_command.c,718 :: 		return true;
ORI	R2, R0, 1
J	L_end_atIsSHAFamily
NOP	
;atca_command.c,720 :: 		default:
L_atIsSHAFamily88:
;atca_command.c,721 :: 		return false;
MOVZ	R2, R0, R0
J	L_end_atIsSHAFamily
NOP	
;atca_command.c,723 :: 		}
L_atIsSHAFamily83:
ANDI	R2, R25, 255
BNE	R2, R0, L__atIsSHAFamily231
NOP	
J	L_atIsSHAFamily85
NOP	
L__atIsSHAFamily231:
ANDI	R3, R25, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atIsSHAFamily233
NOP	
J	L_atIsSHAFamily86
NOP	
L__atIsSHAFamily233:
ANDI	R3, R25, 255
ORI	R2, R0, 2
BNE	R3, R2, L__atIsSHAFamily235
NOP	
J	L_atIsSHAFamily87
NOP	
L__atIsSHAFamily235:
J	L_atIsSHAFamily88
NOP	
;atca_command.c,724 :: 		}
L_end_atIsSHAFamily:
JR	RA
NOP	
; end of _atIsSHAFamily
_atIsECCFamily:
;atca_command.c,731 :: 		bool atIsECCFamily( ATCADeviceType deviceType )
;atca_command.c,733 :: 		switch (deviceType) {
J	L_atIsECCFamily89
NOP	
;atca_command.c,734 :: 		case ATECC108A:
L_atIsECCFamily91:
;atca_command.c,735 :: 		case ATECC508A:
L_atIsECCFamily92:
;atca_command.c,736 :: 		return true;
ORI	R2, R0, 1
J	L_end_atIsECCFamily
NOP	
;atca_command.c,738 :: 		default:
L_atIsECCFamily93:
;atca_command.c,739 :: 		return false;
MOVZ	R2, R0, R0
J	L_end_atIsECCFamily
NOP	
;atca_command.c,741 :: 		}
L_atIsECCFamily89:
ANDI	R3, R25, 255
ORI	R2, R0, 1
BNE	R3, R2, L__atIsECCFamily238
NOP	
J	L_atIsECCFamily91
NOP	
L__atIsECCFamily238:
ANDI	R3, R25, 255
ORI	R2, R0, 2
BNE	R3, R2, L__atIsECCFamily240
NOP	
J	L_atIsECCFamily92
NOP	
L__atIsECCFamily240:
J	L_atIsECCFamily93
NOP	
;atca_command.c,742 :: 		}
L_end_atIsECCFamily:
JR	RA
NOP	
; end of _atIsECCFamily
_isATCAError:
;atca_command.c,749 :: 		ATCA_STATUS isATCAError( uint8_t *data )
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;atca_command.c,751 :: 		uint8_t good[4] = { 0x04, 0x00, 0x03, 0x40 };
SW	R26, 4(SP)
SW	R27, 8(SP)
ORI	R30, R0, 4
SB	R30, 16(SP)
MOVZ	R30, R0, R0
SB	R30, 17(SP)
ORI	R30, R0, 3
SB	R30, 18(SP)
ORI	R30, R0, 64
SB	R30, 19(SP)
;atca_command.c,753 :: 		if ( memcmp( data, good, 4 ) == 0 )
ADDIU	R2, SP, 16
SW	R25, 12(SP)
ORI	R27, R0, 4
MOVZ	R26, R2, R0
JAL	_memcmp+0
NOP	
LW	R25, 12(SP)
SEH	R2, R2
BEQ	R2, R0, L__isATCAError242
NOP	
J	L_isATCAError94
NOP	
L__isATCAError242:
;atca_command.c,754 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_isATCAError
NOP	
L_isATCAError94:
;atca_command.c,756 :: 		if ( data[0] == 0x04 ) {    // error packets are always 4 bytes long
LBU	R2, 0(R25)
ANDI	R3, R2, 255
ORI	R2, R0, 4
BEQ	R3, R2, L__isATCAError243
NOP	
J	L_isATCAError95
NOP	
L__isATCAError243:
;atca_command.c,757 :: 		switch ( data[1] ) {
ADDIU	R4, R25, 1
J	L_isATCAError96
NOP	
;atca_command.c,758 :: 		case 0x01:              // checkmac or verify failed
L_isATCAError98:
;atca_command.c,759 :: 		return ATCA_CHECKMAC_VERIFY_FAILED;
ORI	R2, R0, 209
J	L_end_isATCAError
NOP	
;atca_command.c,761 :: 		case 0x03: // command received byte length, opcode or parameter was illegal
L_isATCAError99:
;atca_command.c,762 :: 		return ATCA_BAD_OPCODE;
ORI	R2, R0, 242
J	L_end_isATCAError
NOP	
;atca_command.c,764 :: 		case 0x0f: // chip can't execute the command
L_isATCAError100:
;atca_command.c,765 :: 		return ATCA_EXECUTION_ERROR;
ORI	R2, R0, 244
J	L_end_isATCAError
NOP	
;atca_command.c,767 :: 		case 0x11: // chip was successfully woken up
L_isATCAError101:
;atca_command.c,768 :: 		return ATCA_WAKE_SUCCESS;
ORI	R2, R0, 243
J	L_end_isATCAError
NOP	
;atca_command.c,770 :: 		case 0xff: // bad crc found or other comm error
L_isATCAError102:
;atca_command.c,771 :: 		return ATCA_STATUS_CRC;
ORI	R2, R0, 212
J	L_end_isATCAError
NOP	
;atca_command.c,773 :: 		default:
L_isATCAError103:
;atca_command.c,774 :: 		return ATCA_GEN_FAIL;
ORI	R2, R0, 225
J	L_end_isATCAError
NOP	
;atca_command.c,776 :: 		}
L_isATCAError96:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BNE	R3, R2, L__isATCAError245
NOP	
J	L_isATCAError98
NOP	
L__isATCAError245:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BNE	R3, R2, L__isATCAError247
NOP	
J	L_isATCAError99
NOP	
L__isATCAError247:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 15
BNE	R3, R2, L__isATCAError249
NOP	
J	L_isATCAError100
NOP	
L__isATCAError249:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 17
BNE	R3, R2, L__isATCAError251
NOP	
J	L_isATCAError101
NOP	
L__isATCAError251:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 255
BNE	R3, R2, L__isATCAError253
NOP	
J	L_isATCAError102
NOP	
L__isATCAError253:
J	L_isATCAError103
NOP	
;atca_command.c,777 :: 		} else
L_isATCAError95:
;atca_command.c,778 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_command.c,779 :: 		}
;atca_command.c,778 :: 		return ATCA_SUCCESS;
;atca_command.c,779 :: 		}
L_end_isATCAError:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _isATCAError
