
__SECURE_HAL_SECURE_HAL_write:
	LNK	#4

	PUSH	W10
	MOV	#0, W0
	MOV	W0, [W14+2]
	MOV	W10, [W14+0]
	MOV	__SECURE_HAL_fpStartI2C, W1
	PUSH	W11
	CALL	W1
	ADD	W14, #2, W2
	ADD	W14, #2, W1
	IOR	W0, [W2], [W1]
	MOV	#lo_addr(__SECURE_HAL_i2cAddress), W0
	ZE	[W0], W0
	SL	W0, #1, W0
	MOV.B	W0, W10
	MOV	__SECURE_HAL_fpWriteI2C, W1
	CALL	W1
	POP	W11
	ADD	W14, #2, W2
	ADD	W14, #2, W1
	IOR	W0, [W2], [W1]
L___SECURE_HAL_SECURE_HAL_write0:
	MOV	W11, W1
	SUB	W11, #1, W0
	MOV	W0, W11
	CP0	W1
	BRA NZ	L___SECURE_HAL_SECURE_HAL_write25
	GOTO	L___SECURE_HAL_SECURE_HAL_write1
L___SECURE_HAL_SECURE_HAL_write25:
	MOV	[W14+0], W0
	PUSH.D	W10
	MOV.B	[W0], W10
	MOV	__SECURE_HAL_fpWriteI2C, W1
	CALL	W1
	POP.D	W10
	ADD	W14, #2, W2
	ADD	W14, #2, W1
	IOR	W0, [W2], [W1]
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
	GOTO	L___SECURE_HAL_SECURE_HAL_write0
L___SECURE_HAL_SECURE_HAL_write1:
	MOV	__SECURE_HAL_fpStopI2C, W0
	PUSH.D	W10
	CALL	W0
	POP.D	W10
	MOV	[W14+2], W0
L_end_SECURE_HAL_write:
	POP	W10
	ULNK
	RETURN
; end of __SECURE_HAL_SECURE_HAL_write

__SECURE_HAL_SECURE_HAL_read:
	LNK	#4

	PUSH	W10
	MOV	#0, W0
	MOV	W0, [W14+2]
	MOV	W10, [W14+0]
	MOV	__SECURE_HAL_fpStartI2C, W1
	PUSH	W11
	CALL	W1
	ADD	W14, #2, W2
	ADD	W14, #2, W1
	IOR	W0, [W2], [W1]
	MOV	#lo_addr(__SECURE_HAL_i2cAddress), W0
	ZE	[W0], W0
	SL	W0, #1, W0
	IOR	W0, #1, W0
	MOV.B	W0, W10
	MOV	__SECURE_HAL_fpWriteI2C, W1
	CALL	W1
	POP	W11
	ADD	W14, #2, W2
	ADD	W14, #2, W1
	IOR	W0, [W2], [W1]
L___SECURE_HAL_SECURE_HAL_read2:
	SUB	W11, #1, W0
	MOV	W0, W11
	CP0	W11
	BRA NZ	L___SECURE_HAL_SECURE_HAL_read27
	GOTO	L___SECURE_HAL_SECURE_HAL_read3
L___SECURE_HAL_SECURE_HAL_read27:
	MOV	#lo_addr(__SECURE_HAL_ACK_BIT), W0
	PUSH.D	W10
	ZE	[W0], W10
	MOV	__SECURE_HAL_fpReadI2C, W1
	CALL	W1
	POP.D	W10
	MOV	[W14+0], W1
	MOV.B	W0, [W1]
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
	GOTO	L___SECURE_HAL_SECURE_HAL_read2
L___SECURE_HAL_SECURE_HAL_read3:
	MOV	#lo_addr(__SECURE_HAL_NACK_BIT), W0
	PUSH.D	W10
	ZE	[W0], W10
	MOV	__SECURE_HAL_fpReadI2C, W1
	CALL	W1
	MOV	[W14+0], W1
	MOV.B	W0, [W1]
	MOV	__SECURE_HAL_fpStopI2C, W0
	CALL	W0
	POP.D	W10
	MOV	[W14+2], W0
L_end_SECURE_HAL_read:
	POP	W10
	ULNK
	RETURN
; end of __SECURE_HAL_SECURE_HAL_read

_secure_4_hal_init:
	LNK	#0

; fpRead start address is: 0 (W0)
	MOV	[W14-8], W0
	MOV	W12, __SECURE_HAL_fpStopI2C
	MOV	W11, __SECURE_HAL_fpStartI2C
	MOV	W13, __SECURE_HAL_fpWriteI2C
	MOV	W0, __SECURE_HAL_fpReadI2C
; fpRead end address is: 0 (W0)
	MOV	#lo_addr(__SECURE_HAL_i2cAddress), W0
	MOV.B	W10, [W0]
L_end_secure_4_hal_init:
	ULNK
	RETURN
; end of _secure_4_hal_init

_hal_i2c_init:
	LNK	#0

	CLR	W0
L_end_hal_i2c_init:
	ULNK
	RETURN
; end of _hal_i2c_init

_hal_i2c_post_init:
	LNK	#0

	CLR	W0
L_end_hal_i2c_post_init:
	ULNK
	RETURN
; end of _hal_i2c_post_init

_hal_i2c_send:
	LNK	#0

	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W11
	CALL	_atgetifacecfg
	POP	W11
	POP	W12
	MOV.B	#3, W0
	MOV.B	W0, [W11]
	ADD	W12, #1, W0
	MOV	W0, W12
	MOV	W11, W10
	MOV	W12, W11
	CALL	__SECURE_HAL_SECURE_HAL_write
	CP0	W0
	BRA Z	L__hal_i2c_send32
	GOTO	L_hal_i2c_send4
L__hal_i2c_send32:
	CLR	W0
	GOTO	L_end_hal_i2c_send
L_hal_i2c_send4:
	MOV.B	#240, W0
L_end_hal_i2c_send:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _hal_i2c_send

_hal_i2c_receive:
	LNK	#0

	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W11
	CALL	_atgetifacecfg
	POP	W11
	POP	W12
	MOV	W11, W10
	MOV	[W12], W11
	CALL	__SECURE_HAL_SECURE_HAL_read
	CP0	W0
	BRA Z	L__hal_i2c_receive34
	GOTO	L_hal_i2c_receive6
L__hal_i2c_receive34:
	CLR	W0
	GOTO	L_end_hal_i2c_receive
L_hal_i2c_receive6:
	MOV.B	#240, W0
L_end_hal_i2c_receive:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _hal_i2c_receive

_hal_i2c_wake:
	LNK	#22

	PUSH	W10
	PUSH	W11
	PUSH	W12
	CALL	_atgetifacecfg
	MOV	W0, [W14+0]
	MOV	#34, W1
	ADD	W0, W1, W1
	MOV	[W1], W1
	MOV	W1, [W14+2]
	INC	W0
	MOV.B	[W0], W0
	MOV.B	W0, [W14+4]
	MOV	#4, W0
	MOV.B	W0, [W14+9]
	MOV	#17, W0
	MOV.B	W0, [W14+10]
	MOV	#51, W0
	MOV.B	W0, [W14+11]
	MOV	#67, W0
	MOV.B	W0, [W14+12]
	ADD	W14, #5, W0
	MOV	#4, W12
	CLR	W11
	MOV	W0, W10
	CALL	_memset
	ADD	W14, #5, W0
	MOV.B	[W0], W0
	CP.B	W0, #0
	BRA NZ	L__hal_i2c_wake36
	GOTO	L_hal_i2c_wake8
L__hal_i2c_wake36:
	GOTO	L_end_hal_i2c_wake
L_hal_i2c_wake8:
	MOV.B	[W14+4], W0
	CP.B	W0, #2
	BRA Z	L__hal_i2c_wake37
	GOTO	L_hal_i2c_wake9
L__hal_i2c_wake37:
L_hal_i2c_wake10:
	MOV	[W14+2], W2
	MOV	[W14+2], W1
	ADD	W14, #2, W0
	SUB	W1, #1, [W0]
	CP	W2, #0
	BRA GT	L__hal_i2c_wake38
	GOTO	L_hal_i2c_wake11
L__hal_i2c_wake38:
	MOV	__SECURE_HAL_fpStartI2C, W0
	PUSH	W10
	CALL	W0
	MOV	#lo_addr(__SECURE_HAL_i2cAddress), W0
	ZE	[W0], W0
	SL	W0, #1, W0
	IOR	W0, #1, W0
	MOV.B	W0, W10
	MOV	__SECURE_HAL_fpWriteI2C, W0
	CALL	W0
	MOV	__SECURE_HAL_fpStopI2C, W0
	CALL	W0
	MOV	#32, W1
	ADD	W14, #0, W0
	ADD	W1, [W0], W0
	MOV	[W0], W2
	CLR	W3
	MOV	#999, W0
	MOV	#0, W1
	ADD	W2, W0, W0
	ADDC	W3, W1, W1
	MOV	#1000, W2
	MOV	#0, W3
	CLR	W4
	CALL	__Divide_32x32
	MOV.D	W0, W10
	CALL	_atca_delay_ms
	MOV	__SECURE_HAL_fpStartI2C, W0
	CALL	W0
	MOV	#lo_addr(__SECURE_HAL_i2cAddress), W0
	ZE	[W0], W0
	SL	W0, #1, W0
	IOR	W0, #1, W0
	MOV.B	W0, W10
	MOV	__SECURE_HAL_fpWriteI2C, W0
	CALL	W0
	ADD	W14, #5, W0
	MOV	W0, [W14+20]
	MOV	W0, [W14+18]
	MOV	#lo_addr(__SECURE_HAL_ACK_BIT), W0
	ZE	[W0], W10
	MOV	__SECURE_HAL_fpReadI2C, W1
	CALL	W1
	MOV	[W14+18], W1
	MOV.B	W0, [W1]
	MOV	[W14+20], W0
	INC	W0
	MOV	W0, [W14+18]
	MOV	#lo_addr(__SECURE_HAL_ACK_BIT), W0
	ZE	[W0], W10
	MOV	__SECURE_HAL_fpReadI2C, W1
	CALL	W1
	MOV	[W14+18], W1
	MOV.B	W0, [W1]
	MOV	[W14+20], W0
	INC2	W0
	MOV	W0, [W14+18]
	MOV	#lo_addr(__SECURE_HAL_ACK_BIT), W0
	ZE	[W0], W10
	MOV	__SECURE_HAL_fpReadI2C, W1
	CALL	W1
	MOV	[W14+18], W1
	MOV.B	W0, [W1]
	MOV	[W14+20], W0
	ADD	W0, #3, W0
	MOV	W0, [W14+18]
	MOV	#lo_addr(__SECURE_HAL_NACK_BIT), W0
	ZE	[W0], W10
	MOV	__SECURE_HAL_fpReadI2C, W1
	CALL	W1
	MOV	[W14+18], W1
	MOV.B	W0, [W1]
	MOV	__SECURE_HAL_fpStopI2C, W0
	CALL	W0
	ADD	W14, #9, W1
	ADD	W14, #5, W0
	MOV	#4, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_memcmp
	POP	W10
	CP0	W0
	BRA Z	L__hal_i2c_wake39
	GOTO	L_hal_i2c_wake12
L__hal_i2c_wake39:
	CLR	W0
	GOTO	L_end_hal_i2c_wake
L_hal_i2c_wake12:
	GOTO	L_hal_i2c_wake10
L_hal_i2c_wake11:
L_hal_i2c_wake9:
	MOV.B	[W14+4], W0
	CP.B	W0, #0
	BRA Z	L__hal_i2c_wake40
	GOTO	L_hal_i2c_wake13
L__hal_i2c_wake40:
	MOV	[W14+2], W0
	CP	W0, #0
	BRA GT	L__hal_i2c_wake41
	GOTO	L_hal_i2c_wake15
L__hal_i2c_wake41:
	MOV	__SECURE_HAL_fpStartI2C, W0
	PUSH	W10
	CALL	W0
	CLR	W10
	MOV	__SECURE_HAL_fpWriteI2C, W0
	CALL	W0
	CLR	W10
	MOV	__SECURE_HAL_fpWriteI2C, W0
	CALL	W0
	MOV	__SECURE_HAL_fpStopI2C, W0
	CALL	W0
	MOV	#32, W1
	ADD	W14, #0, W0
	ADD	W1, [W0], W0
	MOV	[W0], W2
	CLR	W3
	MOV	#999, W0
	MOV	#0, W1
	ADD	W2, W0, W0
	ADDC	W3, W1, W1
	MOV	#1000, W2
	MOV	#0, W3
	CLR	W4
	CALL	__Divide_32x32
	MOV.D	W0, W10
	CALL	_atca_delay_ms
	POP	W10
	CLR	W0
	GOTO	L_end_hal_i2c_wake
L_hal_i2c_wake15:
L_hal_i2c_wake13:
	MOV.B	#240, W0
L_end_hal_i2c_wake:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _hal_i2c_wake

_hal_i2c_idle:
	LNK	#4

	PUSH	W10
	PUSH	W11
	CALL	_atgetifacecfg
	ADD	W14, #0, W1
	MOV.B	#2, W0
	MOV.B	W0, [W1]
	MOV	#1, W11
	MOV	W1, W10
	CALL	__SECURE_HAL_SECURE_HAL_write
	CP0	W0
	BRA NZ	L__hal_i2c_idle43
	GOTO	L_hal_i2c_idle16
L__hal_i2c_idle43:
	CLR	W0
	GOTO	L_end_hal_i2c_idle
L_hal_i2c_idle16:
	MOV.B	#240, W0
L_end_hal_i2c_idle:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _hal_i2c_idle

_hal_i2c_sleep:
	LNK	#4

	PUSH	W10
	PUSH	W11
	CALL	_atgetifacecfg
	ADD	W14, #0, W1
	MOV.B	#1, W0
	MOV.B	W0, [W1]
	MOV	#1, W11
	MOV	W1, W10
	CALL	__SECURE_HAL_SECURE_HAL_write
	CP0	W0
	BRA NZ	L__hal_i2c_sleep45
	GOTO	L_hal_i2c_sleep17
L__hal_i2c_sleep45:
	CLR	W0
	GOTO	L_end_hal_i2c_sleep
L_hal_i2c_sleep17:
	MOV.B	#240, W0
L_end_hal_i2c_sleep:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _hal_i2c_sleep

_hal_i2c_release:
	LNK	#0

	MOV.B	#245, W0
L_end_hal_i2c_release:
	ULNK
	RETURN
; end of _hal_i2c_release

_hal_i2c_discover_buses:
	LNK	#0

	MOV.B	#245, W0
L_end_hal_i2c_discover_buses:
	ULNK
	RETURN
; end of _hal_i2c_discover_buses

_hal_i2c_discover_devices:
	LNK	#0

	MOV.B	#245, W0
L_end_hal_i2c_discover_devices:
	ULNK
	RETURN
; end of _hal_i2c_discover_devices

_atca_delay_us:
	LNK	#0

L_atca_delay_us18:
	MOV.D	W10, W2
	SUB	W10, #1, W0
	SUBB	W11, #0, W1
	MOV.D	W0, W10
	IOR	W3, W2, W0
	BRA NZ	L__atca_delay_us50
	GOTO	L_atca_delay_us19
L__atca_delay_us50:
	CALL	_Delay_1us
	GOTO	L_atca_delay_us18
L_atca_delay_us19:
L_end_atca_delay_us:
	ULNK
	RETURN
; end of _atca_delay_us

_atca_delay_10us:
	LNK	#0

L_atca_delay_10us20:
	MOV.D	W10, W2
	SUB	W10, #1, W0
	SUBB	W11, #0, W1
	MOV.D	W0, W10
	IOR	W3, W2, W0
	BRA NZ	L__atca_delay_10us52
	GOTO	L_atca_delay_10us21
L__atca_delay_10us52:
	CALL	_Delay_10us
	GOTO	L_atca_delay_10us20
L_atca_delay_10us21:
L_end_atca_delay_10us:
	ULNK
	RETURN
; end of _atca_delay_10us

_atca_delay_ms:
	LNK	#0

L_atca_delay_ms22:
	MOV.D	W10, W2
	SUB	W10, #1, W0
	SUBB	W11, #0, W1
	MOV.D	W0, W10
	IOR	W3, W2, W0
	BRA NZ	L__atca_delay_ms54
	GOTO	L_atca_delay_ms23
L__atca_delay_ms54:
	CALL	_Delay_1ms
	GOTO	L_atca_delay_ms22
L_atca_delay_ms23:
L_end_atca_delay_ms:
	ULNK
	RETURN
; end of _atca_delay_ms
