_newATCADevice:
;atca_device.c,56 :: 		ATCADevice newATCADevice(ATCAIfaceCfg *cfg )
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;atca_device.c,58 :: 		ATCADevice cadev = NULL;
SW	R25, 4(SP)
SW	R26, 8(SP)
;atca_device.c,60 :: 		if (cfg == NULL)
BEQ	R25, R0, L__newATCADevice9
NOP	
J	L_newATCADevice0
NOP	
L__newATCADevice9:
;atca_device.c,61 :: 		return NULL;
MOVZ	R2, R0, R0
J	L_end_newATCADevice
NOP	
L_newATCADevice0:
;atca_device.c,63 :: 		cadev = (ATCADevice)Malloc(sizeof(struct atca_device));
SW	R25, 12(SP)
ORI	R25, R0, 8
JAL	_Malloc+0
NOP	
LW	R25, 12(SP)
; cadev start address is: 16 (R4)
MOVZ	R4, R2, R0
;atca_device.c,64 :: 		cadev->mCommands = (ATCACommand)newATCACommand(cfg->devtype);
SW	R2, 20(SP)
ADDIU	R2, R25, 1
SW	R4, 12(SP)
SW	R25, 16(SP)
LBU	R25, 0(R2)
JAL	_newATCACommand+0
NOP	
LW	R25, 16(SP)
LW	R4, 12(SP)
LW	R3, 20(SP)
SW	R2, 0(R3)
;atca_device.c,65 :: 		cadev->mIface    = (ATCAIface)newATCAIface(cfg);
ADDIU	R2, R4, 4
SW	R2, 20(SP)
SW	R4, 12(SP)
JAL	_newATCAIface+0
NOP	
LW	R4, 12(SP)
LW	R3, 20(SP)
SW	R2, 0(R3)
;atca_device.c,67 :: 		if (cadev->mCommands == NULL || cadev->mIface == NULL) {
LW	R2, 0(R4)
BNE	R2, R0, L__newATCADevice11
NOP	
J	L__newATCADevice7
NOP	
L__newATCADevice11:
ADDIU	R2, R4, 4
LW	R2, 0(R2)
BNE	R2, R0, L__newATCADevice13
NOP	
J	L__newATCADevice6
NOP	
L__newATCADevice13:
MOVZ	R2, R4, R0
J	L_newATCADevice3
NOP	
L__newATCADevice7:
L__newATCADevice6:
;atca_device.c,68 :: 		Free((void*)cadev,sizeof(cadev));
ORI	R26, R0, 4
MOVZ	R25, R4, R0
; cadev end address is: 16 (R4)
JAL	_Free+0
NOP	
;atca_device.c,69 :: 		cadev = NULL;
; cadev start address is: 8 (R2)
MOVZ	R2, R0, R0
; cadev end address is: 8 (R2)
;atca_device.c,70 :: 		}
L_newATCADevice3:
;atca_device.c,72 :: 		return cadev;
; cadev start address is: 8 (R2)
; cadev end address is: 8 (R2)
;atca_device.c,73 :: 		}
;atca_device.c,72 :: 		return cadev;
;atca_device.c,73 :: 		}
L_end_newATCADevice:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _newATCADevice
_atGetCommands:
;atca_device.c,79 :: 		ATCACommand atGetCommands( ATCADevice dev )
;atca_device.c,81 :: 		return dev->mCommands;
LW	R2, 0(R25)
;atca_device.c,82 :: 		}
L_end_atGetCommands:
JR	RA
NOP	
; end of _atGetCommands
_atGetIFace:
;atca_device.c,89 :: 		ATCAIface atGetIFace( ATCADevice dev )
;atca_device.c,91 :: 		return dev->mIface;
ADDIU	R2, R25, 4
LW	R2, 0(R2)
;atca_device.c,92 :: 		}
L_end_atGetIFace:
JR	RA
NOP	
; end of _atGetIFace
_deleteATCADevice:
;atca_device.c,99 :: 		void deleteATCADevice( ATCADevice *cadev ) // destructor
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atca_device.c,101 :: 		struct atca_device *dev = *cadev;
SW	R26, 4(SP)
LW	R2, 0(R25)
; dev start address is: 12 (R3)
MOVZ	R3, R2, R0
;atca_device.c,103 :: 		if ( *cadev ) {
BNE	R2, R0, L__deleteATCADevice18
NOP	
J	L_deleteATCADevice4
NOP	
L__deleteATCADevice18:
;atca_device.c,104 :: 		deleteATCACommand( (ATCACommand*)&(dev->mCommands));
SW	R3, 8(SP)
SW	R25, 12(SP)
MOVZ	R25, R3, R0
JAL	_deleteATCACommand+0
NOP	
LW	R25, 12(SP)
LW	R3, 8(SP)
;atca_device.c,105 :: 		deleteATCAIface((ATCAIface*)&(dev->mIface));
ADDIU	R2, R3, 4
; dev end address is: 12 (R3)
SW	R25, 8(SP)
MOVZ	R25, R2, R0
JAL	_deleteATCAIface+0
NOP	
LW	R25, 8(SP)
;atca_device.c,106 :: 		Free((void*)*cadev,sizeof(*cadev));
LW	R2, 0(R25)
SW	R25, 8(SP)
ORI	R26, R0, 4
MOVZ	R25, R2, R0
JAL	_Free+0
NOP	
LW	R25, 8(SP)
;atca_device.c,107 :: 		}
L_deleteATCADevice4:
;atca_device.c,109 :: 		*cadev = NULL;
SW	R0, 0(R25)
;atca_device.c,110 :: 		}
L_end_deleteATCADevice:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _deleteATCADevice
