_atcacert_verify_cert_sw:
;atcacert_host_sw.c,50 :: 		uint8_t ca_public_key[64])
ADDIU	SP, SP, -128
SW	RA, 0(SP)
;atcacert_host_sw.c,52 :: 		int ret = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
;atcacert_host_sw.c,56 :: 		if (cert_def == NULL || ca_public_key == NULL || cert == NULL)
BNE	R25, R0, L__atcacert_verify_cert_sw20
NOP	
J	L__atcacert_verify_cert_sw13
NOP	
L__atcacert_verify_cert_sw20:
BNE	R28, R0, L__atcacert_verify_cert_sw22
NOP	
J	L__atcacert_verify_cert_sw12
NOP	
L__atcacert_verify_cert_sw22:
BNE	R26, R0, L__atcacert_verify_cert_sw24
NOP	
J	L__atcacert_verify_cert_sw11
NOP	
L__atcacert_verify_cert_sw24:
J	L_atcacert_verify_cert_sw2
NOP	
L__atcacert_verify_cert_sw13:
L__atcacert_verify_cert_sw12:
L__atcacert_verify_cert_sw11:
;atcacert_host_sw.c,57 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_verify_cert_sw
NOP	
L_atcacert_verify_cert_sw2:
;atcacert_host_sw.c,59 :: 		ret = atcacert_get_tbs_digest(cert_def, cert, cert_size, tbs_digest);
ADDIU	R2, SP, 32
SW	R28, 16(SP)
SW	R27, 20(SP)
SW	R26, 24(SP)
SW	R25, 28(SP)
MOVZ	R28, R2, R0
JAL	_atcacert_get_tbs_digest+0
NOP	
LW	R25, 28(SP)
LW	R26, 24(SP)
LW	R27, 20(SP)
LW	R28, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_host_sw.c,60 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_verify_cert_sw26
NOP	
J	L_atcacert_verify_cert_sw3
NOP	
L__atcacert_verify_cert_sw26:
;atcacert_host_sw.c,61 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_verify_cert_sw
NOP	
L_atcacert_verify_cert_sw3:
;atcacert_host_sw.c,63 :: 		ret = atcacert_get_signature(cert_def, cert, cert_size, signature);
ADDIU	R2, SP, 64
SW	R28, 16(SP)
MOVZ	R28, R2, R0
JAL	_atcacert_get_signature+0
NOP	
LW	R28, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_host_sw.c,64 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_verify_cert_sw28
NOP	
J	L_atcacert_verify_cert_sw4
NOP	
L__atcacert_verify_cert_sw28:
;atcacert_host_sw.c,65 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_verify_cert_sw
NOP	
L_atcacert_verify_cert_sw4:
;atcacert_host_sw.c,67 :: 		ret = atcac_sw_ecdsa_verify_p256(tbs_digest, signature, ca_public_key);
ADDIU	R3, SP, 64
ADDIU	R2, SP, 32
MOVZ	R27, R28, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcac_sw_ecdsa_verify_p256+0
NOP	
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_host_sw.c,68 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_verify_cert_sw30
NOP	
J	L_atcacert_verify_cert_sw5
NOP	
L__atcacert_verify_cert_sw30:
;atcacert_host_sw.c,69 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_verify_cert_sw
NOP	
L_atcacert_verify_cert_sw5:
;atcacert_host_sw.c,71 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_host_sw.c,72 :: 		}
;atcacert_host_sw.c,71 :: 		return ATCACERT_E_SUCCESS;
;atcacert_host_sw.c,72 :: 		}
L_end_atcacert_verify_cert_sw:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 128
JR	RA
NOP	
; end of _atcacert_verify_cert_sw
_atcacert_gen_challenge_sw:
;atcacert_host_sw.c,74 :: 		int atcacert_gen_challenge_sw( uint8_t challenge[32] )
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atcacert_host_sw.c,76 :: 		if (challenge == NULL)
SW	R26, 4(SP)
BEQ	R25, R0, L__atcacert_gen_challenge_sw32
NOP	
J	L_atcacert_gen_challenge_sw6
NOP	
L__atcacert_gen_challenge_sw32:
;atcacert_host_sw.c,77 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_gen_challenge_sw
NOP	
L_atcacert_gen_challenge_sw6:
;atcacert_host_sw.c,79 :: 		return atcac_sw_random(challenge, 32);
ORI	R26, R0, 32
JAL	_atcac_sw_random+0
NOP	
;atcacert_host_sw.c,80 :: 		}
;atcacert_host_sw.c,79 :: 		return atcac_sw_random(challenge, 32);
;atcacert_host_sw.c,80 :: 		}
L_end_atcacert_gen_challenge_sw:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atcacert_gen_challenge_sw
_atcacert_verify_response_sw:
;atcacert_host_sw.c,84 :: 		uint8_t response[64])
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;atcacert_host_sw.c,86 :: 		if (device_public_key == NULL || challenge == NULL || response == NULL)
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
BNE	R25, R0, L__atcacert_verify_response_sw35
NOP	
J	L__atcacert_verify_response_sw17
NOP	
L__atcacert_verify_response_sw35:
BNE	R26, R0, L__atcacert_verify_response_sw37
NOP	
J	L__atcacert_verify_response_sw16
NOP	
L__atcacert_verify_response_sw37:
BNE	R27, R0, L__atcacert_verify_response_sw39
NOP	
J	L__atcacert_verify_response_sw15
NOP	
L__atcacert_verify_response_sw39:
J	L_atcacert_verify_response_sw9
NOP	
L__atcacert_verify_response_sw17:
L__atcacert_verify_response_sw16:
L__atcacert_verify_response_sw15:
;atcacert_host_sw.c,87 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_verify_response_sw
NOP	
L_atcacert_verify_response_sw9:
;atcacert_host_sw.c,89 :: 		return atcac_sw_ecdsa_verify_p256(challenge, response, device_public_key);
SW	R26, 16(SP)
MOVZ	R26, R27, R0
MOVZ	R27, R25, R0
LW	R25, 16(SP)
JAL	_atcac_sw_ecdsa_verify_p256+0
NOP	
;atcacert_host_sw.c,90 :: 		}
;atcacert_host_sw.c,89 :: 		return atcac_sw_ecdsa_verify_p256(challenge, response, device_public_key);
;atcacert_host_sw.c,90 :: 		}
L_end_atcacert_verify_response_sw:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _atcacert_verify_response_sw
