_atcac_sw_sha1_init:
;atca_crypto_sw_sha1.c,46 :: 		int atcac_sw_sha1_init(atcac_sha1_ctx* ctx)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_crypto_sw_sha1.c,49 :: 		return ATCA_ASSERT_FAILURE; // atcac_sha1_ctx isn't large enough for this implementation
L_atcac_sw_sha1_init0:
;atca_crypto_sw_sha1.c,50 :: 		CL_hashInit((CL_HashContext*)ctx);
JAL	_CL_hashInit+0
NOP	
;atca_crypto_sw_sha1.c,52 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha1.c,53 :: 		}
L_end_atcac_sw_sha1_init:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcac_sw_sha1_init
_atcac_sw_sha1_update:
;atca_crypto_sw_sha1.c,55 :: 		int atcac_sw_sha1_update(atcac_sha1_ctx* ctx,  uint8_t* data, size_t data_size)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_crypto_sw_sha1.c,57 :: 		CL_hashUpdate((CL_HashContext*)ctx, data, (int)data_size);
JAL	_CL_hashUpdate+0
NOP	
;atca_crypto_sw_sha1.c,59 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha1.c,60 :: 		}
L_end_atcac_sw_sha1_update:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcac_sw_sha1_update
_atcac_sw_sha1_finish:
;atca_crypto_sw_sha1.c,62 :: 		int atcac_sw_sha1_finish(atcac_sha1_ctx* ctx, uint8_t digest[ATCA_SHA1_DIGEST_SIZE])
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_crypto_sw_sha1.c,64 :: 		CL_hashFinal((CL_HashContext*)ctx, digest);
JAL	_CL_hashFinal+0
NOP	
;atca_crypto_sw_sha1.c,66 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha1.c,67 :: 		}
L_end_atcac_sw_sha1_finish:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcac_sw_sha1_finish
_atcac_sw_sha1:
;atca_crypto_sw_sha1.c,69 :: 		int atcac_sw_sha1( uint8_t* data, size_t data_size, uint8_t digest[ATCA_SHA1_DIGEST_SIZE])
ADDIU	SP, SP, -152
SW	RA, 0(SP)
;atca_crypto_sw_sha1.c,74 :: 		ret = atcac_sw_sha1_init(&ctx);
SW	R25, 4(SP)
SW	R26, 8(SP)
ADDIU	R2, SP, 24
SW	R27, 12(SP)
SW	R26, 16(SP)
SW	R25, 20(SP)
MOVZ	R25, R2, R0
JAL	_atcac_sw_sha1_init+0
NOP	
LW	R25, 20(SP)
LW	R26, 16(SP)
LW	R27, 12(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atca_crypto_sw_sha1.c,75 :: 		if (ret != ATCA_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcac_sw_sha19
NOP	
J	L_atcac_sw_sha11
NOP	
L__atcac_sw_sha19:
;atca_crypto_sw_sha1.c,76 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcac_sw_sha1
NOP	
L_atcac_sw_sha11:
;atca_crypto_sw_sha1.c,78 :: 		ret = atcac_sw_sha1_update(&ctx, data, data_size);
ADDIU	R2, SP, 24
SW	R27, 12(SP)
MOVZ	R27, R26, R0
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_atcac_sw_sha1_update+0
NOP	
LW	R27, 12(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atca_crypto_sw_sha1.c,79 :: 		if (ret != ATCA_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcac_sw_sha111
NOP	
J	L_atcac_sw_sha12
NOP	
L__atcac_sw_sha111:
;atca_crypto_sw_sha1.c,80 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcac_sw_sha1
NOP	
L_atcac_sw_sha12:
;atca_crypto_sw_sha1.c,82 :: 		ret = atcac_sw_sha1_finish(&ctx, digest);
ADDIU	R2, SP, 24
MOVZ	R26, R27, R0
MOVZ	R25, R2, R0
JAL	_atcac_sw_sha1_finish+0
NOP	
; ret start address is: 12 (R3)
SEH	R3, R2
;atca_crypto_sw_sha1.c,83 :: 		if (ret != ATCA_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcac_sw_sha113
NOP	
J	L_atcac_sw_sha13
NOP	
L__atcac_sw_sha113:
;atca_crypto_sw_sha1.c,84 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcac_sw_sha1
NOP	
L_atcac_sw_sha13:
;atca_crypto_sw_sha1.c,86 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha1.c,87 :: 		}
;atca_crypto_sw_sha1.c,86 :: 		return ATCA_SUCCESS;
;atca_crypto_sw_sha1.c,87 :: 		}
L_end_atcac_sw_sha1:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 152
JR	RA
NOP	
; end of _atcac_sw_sha1
