_hal_iface_init:
;atca_hal.c,57 :: 		ATCA_STATUS hal_iface_init( ATCAIfaceCfg *cfg, ATCAHAL_t *hal )
ADDIU	SP, SP, -4
;atca_hal.c,63 :: 		ATCA_STATUS status = ATCA_COMM_FAIL;
ORI	R30, R0, 240
SB	R30, 0(SP)
;atca_hal.c,65 :: 		switch (cfg->iface_type)
MOVZ	R4, R25, R0
J	L_hal_iface_init0
NOP	
;atca_hal.c,67 :: 		case ATCA_I2C_IFACE:
L_hal_iface_init2:
;atca_hal.c,69 :: 		hal->halinit = &hal_i2c_init;
LUI	R2, hi_addr(_hal_i2c_init+0)
ORI	R2, R2, lo_addr(_hal_i2c_init+0)
SW	R2, 0(R26)
;atca_hal.c,70 :: 		hal->halpostinit = &hal_i2c_post_init;
ADDIU	R3, R26, 4
LUI	R2, hi_addr(_hal_i2c_post_init+0)
ORI	R2, R2, lo_addr(_hal_i2c_post_init+0)
SW	R2, 0(R3)
;atca_hal.c,71 :: 		hal->halreceive = &hal_i2c_receive;
ADDIU	R3, R26, 12
LUI	R2, hi_addr(_hal_i2c_receive+0)
ORI	R2, R2, lo_addr(_hal_i2c_receive+0)
SW	R2, 0(R3)
;atca_hal.c,72 :: 		hal->halsend = &hal_i2c_send;
ADDIU	R3, R26, 8
LUI	R2, hi_addr(_hal_i2c_send+0)
ORI	R2, R2, lo_addr(_hal_i2c_send+0)
SW	R2, 0(R3)
;atca_hal.c,73 :: 		hal->halsleep = &hal_i2c_sleep;
ADDIU	R3, R26, 24
LUI	R2, hi_addr(_hal_i2c_sleep+0)
ORI	R2, R2, lo_addr(_hal_i2c_sleep+0)
SW	R2, 0(R3)
;atca_hal.c,74 :: 		hal->halwake = &hal_i2c_wake;
ADDIU	R3, R26, 16
LUI	R2, hi_addr(_hal_i2c_wake+0)
ORI	R2, R2, lo_addr(_hal_i2c_wake+0)
SW	R2, 0(R3)
;atca_hal.c,75 :: 		hal->halidle = &hal_i2c_idle;
ADDIU	R3, R26, 20
LUI	R2, hi_addr(_hal_i2c_idle+0)
ORI	R2, R2, lo_addr(_hal_i2c_idle+0)
SW	R2, 0(R3)
;atca_hal.c,76 :: 		hal->halrelease = &hal_i2c_release;
ADDIU	R3, R26, 28
LUI	R2, hi_addr(_hal_i2c_release+0)
ORI	R2, R2, lo_addr(_hal_i2c_release+0)
SW	R2, 0(R3)
;atca_hal.c,77 :: 		hal->hal_data = NULL;
ADDIU	R2, R26, 32
SW	R0, 0(R2)
;atca_hal.c,79 :: 		status = ATCA_SUCCESS;
SB	R0, 0(SP)
;atca_hal.c,81 :: 		break;
J	L_hal_iface_init1
NOP	
;atca_hal.c,82 :: 		case ATCA_SWI_IFACE:
L_hal_iface_init3:
;atca_hal.c,96 :: 		break;
J	L_hal_iface_init1
NOP	
;atca_hal.c,97 :: 		case ATCA_UART_IFACE:
L_hal_iface_init4:
;atca_hal.c,114 :: 		break;
J	L_hal_iface_init1
NOP	
;atca_hal.c,115 :: 		case ATCA_SPI_IFACE:
L_hal_iface_init5:
;atca_hal.c,119 :: 		break;
J	L_hal_iface_init1
NOP	
;atca_hal.c,120 :: 		case ATCA_HID_IFACE:
L_hal_iface_init6:
;atca_hal.c,134 :: 		break;
J	L_hal_iface_init1
NOP	
;atca_hal.c,135 :: 		}
L_hal_iface_init0:
LBU	R2, 0(R4)
ANDI	R2, R2, 255
BNE	R2, R0, L__hal_iface_init16
NOP	
J	L_hal_iface_init2
NOP	
L__hal_iface_init16:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 1
BNE	R3, R2, L__hal_iface_init18
NOP	
J	L_hal_iface_init3
NOP	
L__hal_iface_init18:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BNE	R3, R2, L__hal_iface_init20
NOP	
J	L_hal_iface_init4
NOP	
L__hal_iface_init20:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BNE	R3, R2, L__hal_iface_init22
NOP	
J	L_hal_iface_init5
NOP	
L__hal_iface_init22:
LBU	R2, 0(R4)
ANDI	R3, R2, 255
ORI	R2, R0, 4
BNE	R3, R2, L__hal_iface_init24
NOP	
J	L_hal_iface_init6
NOP	
L__hal_iface_init24:
L_hal_iface_init1:
;atca_hal.c,136 :: 		return status;
LBU	R2, 0(SP)
;atca_hal.c,137 :: 		}
L_end_hal_iface_init:
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _hal_iface_init
_hal_iface_release:
;atca_hal.c,144 :: 		ATCA_STATUS hal_iface_release( ATCAIfaceType ifacetype, void *hal_data )
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atca_hal.c,146 :: 		ATCA_STATUS status = ATCA_GEN_FAIL;
SW	R25, 4(SP)
ORI	R30, R0, 225
SB	R30, 8(SP)
;atca_hal.c,148 :: 		switch (ifacetype)
J	L_hal_iface_release7
NOP	
;atca_hal.c,150 :: 		case ATCA_I2C_IFACE:
L_hal_iface_release9:
;atca_hal.c,152 :: 		status = hal_i2c_release(hal_data);
MOVZ	R25, R26, R0
JAL	_hal_i2c_release+0
NOP	
SB	R2, 8(SP)
;atca_hal.c,154 :: 		break;
J	L_hal_iface_release8
NOP	
;atca_hal.c,155 :: 		case ATCA_SWI_IFACE:
L_hal_iface_release10:
;atca_hal.c,159 :: 		break;
J	L_hal_iface_release8
NOP	
;atca_hal.c,160 :: 		case ATCA_UART_IFACE:
L_hal_iface_release11:
;atca_hal.c,167 :: 		break;
J	L_hal_iface_release8
NOP	
;atca_hal.c,168 :: 		case ATCA_SPI_IFACE:
L_hal_iface_release12:
;atca_hal.c,172 :: 		break;
J	L_hal_iface_release8
NOP	
;atca_hal.c,173 :: 		case ATCA_HID_IFACE:
L_hal_iface_release13:
;atca_hal.c,177 :: 		break;
J	L_hal_iface_release8
NOP	
;atca_hal.c,178 :: 		}
L_hal_iface_release7:
ANDI	R2, R25, 255
BNE	R2, R0, L__hal_iface_release27
NOP	
J	L_hal_iface_release9
NOP	
L__hal_iface_release27:
ANDI	R3, R25, 255
ORI	R2, R0, 1
BNE	R3, R2, L__hal_iface_release29
NOP	
J	L_hal_iface_release10
NOP	
L__hal_iface_release29:
ANDI	R3, R25, 255
ORI	R2, R0, 2
BNE	R3, R2, L__hal_iface_release31
NOP	
J	L_hal_iface_release11
NOP	
L__hal_iface_release31:
ANDI	R3, R25, 255
ORI	R2, R0, 3
BNE	R3, R2, L__hal_iface_release33
NOP	
J	L_hal_iface_release12
NOP	
L__hal_iface_release33:
ANDI	R3, R25, 255
ORI	R2, R0, 4
BNE	R3, R2, L__hal_iface_release35
NOP	
J	L_hal_iface_release13
NOP	
L__hal_iface_release35:
L_hal_iface_release8:
;atca_hal.c,180 :: 		return status;
LBU	R2, 8(SP)
;atca_hal.c,181 :: 		}
;atca_hal.c,180 :: 		return status;
;atca_hal.c,181 :: 		}
L_end_hal_iface_release:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _hal_iface_release
